#define Vertex int
#include <stdlib.h>
#include <stdio.h>

typedef struct node *Link;

struct node {
    Vertex w;
    Link next;
};

struct digraph {
  int V;  // qtde de vertices
  int A;  // qtde de arcos
  Link *adj; // adj e um ponteiro para um vetor de ponteiros
};

typedef struct digraph *Digraph;

#define graph digraph
#define Graph Digraph

Digraph initDigraph(int V) {
   int i;
   Digraph G = (Digraph) malloc(sizeof(*G));
   G->V = V;
   G->A = 0;
   G->adj = (Link *) malloc(V*sizeof(Link *));
   for (i=0; i<V; i++) {
     G->adj[i] = NULL;
   }
   return G;  
}

Link NewArc(Vertex w, Link next) {
    Link x = malloc(sizeof (*x));
    x->w = w;
    x->next = next;
    return x;
}

void insertArc(Digraph G, Vertex v, Vertex w) {
    Link p;
    if (v == w) return;
    
    for (p=G->adj[v]; p!= NULL; p = p->next) {
          if(p->w == w) return; 
    }
  
    G->adj[v] = NewArc(w, G->adj[v]);
    G->A++;
}

void removeArc(Digraph G, Vertex v, Vertex w) {
    Link p, ant;
    
    p=G->adj[v];
    if (p == NULL) return;
    
    if (p->w == w) {
        G->adj[v] = p->next;
	free(p);
	p = NULL;
	G->A--;
	return;
    }
    
    for (p=G->adj[v]->next; p != NULL; p = p->next) {
          if (p->w == w) {
	     ant->next = p->next; 
	     free(p);
	     G->A--;
	  }
          ant = p;
    }
}

void printDigraph(Digraph G) {
   Link p;
   int i, V;
   V = G->V;
   
   printf("\nTotal of vertices: %d, total of arcs: %d\n", G->V, G->A);
   for (i=0; i<V; i++) {
      printf("* Vertex %d: \n", i);
      for (p=G->adj[i]; p!=NULL; p=p->next) {
	  printf("  -> %d\n", p->w);
      }
   }
}

#define printGraph printDigraph
#define initGraph initDigraph

void insertEdge(Graph G, Vertex v, Vertex w) {
   insertArc(G,v,w);
   insertArc(G,w,v);
}

void removeEdge(Graph G, Vertex v, Vertex w) {
   removeArc(G,v,w);
   removeArc(G,w,v);
}
