#include <stdlib.h>
#include <stdio.h>

#define Vertex int

typedef struct {
  Vertex v;
  Vertex w;
} Arc;

Arc newArc(Vertex v, Vertex w) {
  Arc e;
  e.v = v;
  e.w = w;
  return e;
}

typedef struct {
  int size;
  Arc *arcs;
} ArcList;

ArcList initArcList() {
   ArcList al;
   al.size = 0;
   al.arcs = NULL;
   return al;
}

void destroyArcList(ArcList *al) {
   free(al->arcs);
   al->size = 0;
}

int searchArc(ArcList *al, Arc *a) {
  int i;
  for (i=0; i < (al->size); i++) {
     if ((al->arcs[i].v == a->v) &&
         (al->arcs[i].w == a->w)) {
        return 1;
      }
  }
  return 0;
}

void insertArc(ArcList *al, Arc *newa) {
   if (searchArc(al,newa))
      return;
   
   al->size++;
   al->arcs = (Arc *) realloc(al->arcs, sizeof(Arc)*al->size);
   al->arcs[al->size-1] = *newa; 
}

void printArcList(ArcList *al) {
   int i;
   
   for (i = 0; i<(al->size); i++) {
      printf("(%d -- %d)\n", al->arcs[i].v, al->arcs[i].w); 
   }
  
}

#define Edge Arc
#define EDGE ARC